#!/usr/bin/env sh
+has_command() {
+ command -v "$1" >/dev/null 2>/dev/null
+ return $?
+}
+
USE_GLOW=false
USE_BAT=false
-if command -v glow >/dev/null 2>/dev/null; then
+USE_PYGMENTIZE=false
+USE_HIGHLIGHT=false
+if has_command glow; then
USE_GLOW=true
-elif command -v bat >/dev/null 2>/dev/null; then
- USE_BAT=true
- printf "Glow not found, markdown rendering will be done by bat.\n"
- printf "Install glow for easier reading & copy-paste.\n"
else
- printf "Glow or bat not found, markdown rendering not available.\n"
- printf "Output will be raw markdown and might look weird.\n"
+ if has_command bat; then
+ USE_BAT=true
+ printf "Markdown rendering will be done by bat. (Glow is recommended)\n"
+ elif has_command pygmentize; then
+ printf "Markdown rendering will be done by pygmentize. (Glow is recommended)\n"
+ USE_PYGMENTIZE=true
+ elif has_command highlight; then
+ printf "Markdown rendering will be done by highlight. (Glow is recommended)\n"
+ USE_HIGHLIGHT=true
+ else
+ printf "Markdown rendering not available. (Glow is recommended)\n"
+ printf "Output will be raw markdown and might look weird.\n"
+ fi
printf "Install glow for easier reading & copy-paste.\n"
fi
fi
if ! command -v jq >/dev/null 2>/dev/null; then
- printf "jq is needed to run this script, but it wasn't found. Please install it to be able to use this script."
+ printf "jq is needed to run this script, but it wasn't found. Please install it to be able to use this script.\n"
exit
fi
}
# Returns 0 if the path doesn't lead anywhere
-# Return 1 if the path points to a file, 2 if it points to a directory
-check_not_exists_file() {
+# Returns 1 if the path leads to something
+check_if_file_exists() {
FILE_PATH=$(apply_shell_expansion "$1")
- if [ -f "$FILE_PATH" ]; then
+ if [ -e "$FILE_PATH" ]; then
return 1
- elif [ -d "$FILE_PATH" ]; then
- return 2
else
return 0
fi
}
+decode_string() {
+ printf "%s" "$1" | sed -e 's/\\n/\
+/g' -e 's/\\\"/\"/g' -e '$ s/\n*$/\
+\
+/' # Replace \n with literal newline and \" with ", normalize number of trailing newlines to 2
+}
+
# Function to handle the formatting of output
log() {
MODE="$1"
;;
HELP)
- if $USE_GLOW; then
- printf "%s\n" "$HELP" | glow -
- elif $USE_BAT; then
- printf "%s\n" "$HELP" | bat -pp --decorations=always --color=always --language markdown
+ if [ "$USE_GLOW" = true ]; then
+ decode_string "$HELP" | glow -
+ elif [ "$USE_BAT" = true ]; then
+ decode_string "$HELP" | bat -pp --decorations=always --color=always --language markdown
+ elif [ $USE_PYGMENTIZE = true ]; then
+ decode_string "$HELP" | pygmentize -l markdown
+ printf "\n"
+ elif [ $USE_HIGHLIGHT = true ]; then
+ decode_string "$HELP" | highlight --out-format ansi --syntax markdown
else
- printf "%s\n" "$HELP"
+ decode_string "$HELP"
fi
;;
# Checks that the given file does not exist, otherwise outputs help
check_file() {
- INPUT="$1"
- NAME="$2"
-
- FILENAME=$(printf "%s" "$INPUT" | jq -r .path)
- MOVABLE=$(printf "%s" "$INPUT" | jq -r .movable)
- HELP=$(printf "%s" "$INPUT" | jq -r .help)
+ NAME="$1"
+ FILENAME="$2"
+ MOVABLE="$3"
+ HELP="$4"
- check_not_exists_file "$FILENAME"
+ check_if_file_exists "$FILENAME"
case $? in
log SUCS "$NAME" "$FILENAME" "$HELP"
;;
- 1 | 2)
- if "$MOVABLE"; then
+ 1)
+ if [ "$MOVABLE" = true ]; then
log ERR "$NAME" "$FILENAME" "$HELP"
else
log WARN "$NAME" "$FILENAME" "$HELP"
esac
}
-# Reads a file from programs/, calls check_file on each file specified for the program
-check_program() {
- PROGRAM=$1
-
- NAME=$(jq -r .name "$PROGRAM")
-
- while IFS= read -r file; do
- check_file "$file" "$NAME"
+# Reads files from programs/, calls check_file on each file specified for each program
+do_check_programs() {
+ while IFS="
+" read -r name; read -r filename; read -r movable; read -r help; do
+ check_file "$name" "$filename" "$movable" "$help"
done <<EOF
-$(jq -rc '.files[]' "$PROGRAM")
+$(jq 'inputs as $input | $input.files[] as $file | $input.name, $file.path, $file.movable, $file.help' "$(dirname "$0")"/programs/* | sed -e 's/^"//' -e 's/"$//')
EOF
+# sed is to trim quotes
}
-# Loops over all files in the programs/ directory and calls check_program
-enumerate_programs() {
+check_programs() {
printf "\033[1;3mStarting to check your \033[1;36m\$HOME.\033[1;0m\n"
printf "\n"
- for prog_filename in "$(dirname "$0")"/programs/*; do
- check_program "$prog_filename"
- done
+ do_check_programs
printf "\033[1;3mDone checking your \033[1;36m\$HOME.\033[1;0m\n"
printf "\n"
printf "\033[3mIf you have files in your \033[1;36m\$HOME\033[1;0m that shouldn't be there, but weren't recognised by xdg-ninja, please consider creating a configuration file for it and opening a pull request on github.\033[1;0m\n"
printf "\n"
}
-enumerate_programs
+check_programs